/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.catalog.ui.productLastViewed
 *
 * @revision		$Revision: 1.3 $
 */

jQuery.plugin('de_epages.catalog.ui.productLastViewed', ['de_epages.core', 'jQuery.ui.widget', 'jQuery.storage', 'jQuery.tmpl'], function( $, undefined ){

	$.widget( 'de_epages.catalog.ui.ProductLastViewed', {

		options: {
			maxItems: 5
		},

		_create: function(){
			this.listElem = $('<ul>').addClass('de_epages-catalogUiProductLastViewed');

			this.products = $.localStorage('Catalog::ProductLastViewed.list');

			if( this.products ){

				var tstampMap = [],
					tstampData = [],
					tmplData = [],
					maxItems = this.options.maxItems-1;
				
				// create am map with tstamps to sort
				$.each( this.products, function( id, product ){
					tstampMap.push( product.tstamp );
					tstampData[ product.tstamp ] = product;
				});
				
				// sort
				tstampMap = tstampMap.sort().reverse();

				// push products in the right order
				$.each( tstampMap, function( i, tstamp ){
					tmplData.push( tstampData[ tstamp ] );

					if( i >= maxItems ){
						return false;
					}
				});

				// append elements via template
				this.element.append( this.listElem.append( $.tmpl( '<li><a href="?ObjectPath=${objectPath}"><img src="${image}" />${name}</a></li>', tmplData ) ) );
			}
		},

		destroy: function(){
			this.listElem.remove();

			this.Inherited(arguments);
		}
	});

});
