#!/bin/env perl

use strict;
use Getopt::Long;

sub usage {
    print <<END_USAGE;
Usage:
    perl $0 [-nooutput] SECONDS
Description:
    Sleep for SECONDS
Options:
    -nooutput           do not print any output
    -help               show the command line options
Example:
    perl $0 10
END_USAGE
    exit 2;
}

my %Options = ();
my @GetOpt = qw(help nooutput);

usage() unless GetOptions(\%Options, @GetOpt);
usage() if defined $Options{help};
usage() unless scalar @ARGV == 1;

print "sleep $ARGV[0]\n" unless $Options{nooutput};
sleep $ARGV[0];
