use Test::Simple tests => 14;
use strict;

use DE_EPAGES::Core::API::Script qw( RunScript );


#--------------------------------------------------------------------------------------
sub AddressSplit {
    #$Address - Address to split
    #$Result_str - expected streetname after splitting
    #$Result_hnr - expected housenumber after splitting
    my ($Address, $Result_str, $Result_hnr) = @_;

    my ($str,$hnr) = split(/\s*([0-9].*)/,$Address);

    my $Result;
    if ( ($str eq $Result_str) && ($hnr eq $Result_hnr) ) {
        $Result = 1;
    }
    else {
        $Result = 0;
    }
    ok($Result,'test AddressSplit: '.$Address);
}


#--------------------------------------------------------------------------------------
RunScript(
    'Sub' => sub {
        ok( 1, 'test started' );

        #Testcases:  Address                   expected street       expected houseNr
        AddressSplit('Pilatuspool 2',          'Pilatuspool',        '2'            );
        AddressSplit('Pilatuspool2',           'Pilatuspool',        '2'            );
        AddressSplit('Pilatuspool 15a',        'Pilatuspool',        '15a'          );
        AddressSplit('Pilatuspool 15 a',       'Pilatuspool',        '15 a'         );
        AddressSplit('Pilatuspool 15 a-c',     'Pilatuspool',        '15 a-c'       );
        AddressSplit('Pilatuspool 15a-c',      'Pilatuspool',        '15a-c'        );
        AddressSplit('Pilatuspool 15 a - c',   'Pilatuspool',        '15 a - c'     );
        AddressSplit('Pilatuspool 15 - 17',    'Pilatuspool',        '15 - 17'      );
        AddressSplit('Pilatuspool 15-17',      'Pilatuspool',        '15-17'        );
        AddressSplit('Pilatuspool 15 - 17 a',  'Pilatuspool',        '15 - 17 a'    );
        AddressSplit('Pilatuspool 15-17 a',    'Pilatuspool',        '15-17 a'      );
        AddressSplit('Pilatuspool 15-17a',     'Pilatuspool',        '15-17a'       );
        #Edge Case
        AddressSplit('Platz des 4.Oktober 15', 'Platz des',          '4.Oktober 15' );

        return;
    }

);
