/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.mcecontent $Revision: 1.57 $

*/
dojo.provide('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.string');
dojo.require('epages.lang.hash');

dojo.require('epages.html.form');
dojo.require('epages.html.element');

dojo.require('epages.io.translation');
dojo.require('epages.validate.string');

epages.cartridges.de_epages.design.MceContent = epages.Class();

epages.cartridges.de_epages.design.MceContent.prototype = {
	/* constants */
	DIALOG_HEIGHT : "400",	// synchronized with .GadgetTable in BackOfficeStyle.css
	DIALOG_WIDTH  : "830",	// synchronized with .GadgetTable in BackOfficeStyle.css
	/* properties */
	navElementId: '',
	contentClass : 'epages.cartridges.de_epages.design.MceContent',
	base64 : new epages.string.Base64,
	preview: '', 						// path to the MBO preview images, e.g.: epages.vars.StoreRoot + '/BO/icons/content_ico_m_navelementgroup_flash.gif
	transparent: epages.vars.StoreRoot + '/BO/icons/general_img_transparentpixel.gif',
	dictionary : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.design.widget', "templates/translation"),"auto"),
	title:  'content',
	width : 400,
	height: 400,
	doInsertDom: true,
	form     : undefined,
	group: null,
	formData : $H(),
	directPreview: true,

	initialize: function(options){
		this.save(options);
	},

	updateForm: function() {
		if (this.form !== undefined) {
			this.formData = $H(this.formData);
			(new epages.html.Form(this.form)).set(this.formData,true);
		}
	},

	saveForm: function() {
		if (this.form !== undefined){
			var formElements = this.form.elements;
			for( var i=0,iLength=formElements.length ; i<iLength ; i++ ){
				if(formElements[i].value){
					formElements[i].value = epages.validate.string.filterInvalidChars(formElements[i].value);
				}
			}
			this.formData = (new epages.html.Form(this.form)).get();
		}
	},

	save: function (options) {
		if (options !== undefined) {
			dojo.mixin(this, options);
			this.formData = $H(this.formData);
		}
	},

	info: function () {
		return {
			width        : this.width,
			height       : this.height,
			contentClass : this.contentClass,
			navElementId : this.navElementId,
			formData     : this.formData,
			preview      : this.preview,
			title        : this.title,
			group        : (epages.vars.externalcontent && epages.vars.externalcontent.currentGroupAlias) ? epages.vars.externalcontent.currentGroupAlias : '',
			autostart		 : this.autostart ? this.autostart : '',
			loop				 : this.loop ? this.loop : ''
		};
	},

	toString: function() {
		return "new " + this.contentClass + "(" + $H(this.info()).toString() + ")";
	},

	encodeInfo: function(info) {
		return this.base64.encode($H(info).toString());
	},

	decodeInfo: function(string) {
		var info = eval("(" + this.base64.decode(string) + ")");
		if (info.formData !== undefined){
			info.formData = $H(info.formData);
		}
		return info;
	},

	mceOpenWindow: function (editor_id, groupid) {
		var inst = tinyMCE.editors[editor_id];
		//var focusElm = inst.getFocusElement();
		var focusElm = inst.selection.getNode();

		var wrapper = null;
		// Is selection a image
		if (focusElm != null) {
			if (focusElm.nodeName.toLowerCase() == "img" && tinymce.DOM.getAttrib(focusElm, 'class').indexOf('epItemContent') > -1){
				wrapper = focusElm;
			}
		}

		var template = {};
		if (epages.vars.BaseUrl === undefined){
			epages.vars.BaseUrl = '';
		}
		template['url'] = epages.vars.BaseUrl +'?ViewAction=MBO-ViewPluginEpContent&ObjectID=' + epages.vars.ObjectID;
		if (epages.vars.DefaultParams != null){
			template['url'] += epages.vars.DefaultParams;
		}
		if (wrapper != null) {
		  var ep_info = tinymce.DOM.getAttrib(wrapper, 'ep_info');
			template['url'] += '&ContentData=' + ep_info;
			var navElementId = (this.decodeInfo(ep_info)).navElementId;
			if (navElementId !== undefined){
			  template['url'] += '&NavElementID=' + navElementId;
			}
		}
		if (groupid != null){
			template['url'] += '&GroupID=' + groupid;
		}

		template['width']  = this.DIALOG_WIDTH;
		template['height'] = this.DIALOG_HEIGHT;
		template['scrollbars'] = "yes";
		template['resizable'] = "yes";
		template['title'] = this.dictionary.get("InsertGadget");

		inst.windowManager.open(template, {editor_id : editor_id, inline : "yes", mce_replacevariables:false });
	},

	contentString: function(info) {
		return ['<img src="' + info.preview,
			'width="'  + info.width,
			'height="' + info.height,
			'alt="'    + this.title,
			'title="'  + this.title,
			'/>'
		].join('" ');
	},

	previewString: function(info) {
		var width = (info.width.toString().match(/%/)) ? info.width : info.width+'px';
		var height = (info.height.toString().match(/%/)) ? info.height : info.height+'px';
		return ['<img class="epItemContent',
			'src="' + this.transparent,
			'style="background-image: url('+ info.preview+');height:'+height+'; width:'+width+';"',
			'ep_style="background-image: url('+ info.preview+');height:'+height+'; width:'+width+';"',
			'width="'  + info.width,
			'height="' + info.height,
			'alt="'  + this.title,
			'title="'  + this.title,
			'ep_info="' + this.encodeInfo(info),
			'ep_dom="' + (this.doInsertDom ? 'true' : 'false'),
			'ep_group="' + info.group,
			'/>'
		].join('" ');
	},

	mceInsertContent: function (info) {
		if (info === undefined){
			info = this.info();
		}
		if (typeof (window.ep_InsertContent) == 'function') {
			window.ep_InsertContent(this,info);
		} else {
			var html = this.previewString(info);
			//go back to saved bookmark necessary for ie
			tinyMCE.activeEditor.selection.moveToBookmark(tinymce.WindowManager.bookmark);
			tinyMCE.execCommand("mceInsertContent", true, html);
		}
	},

	parseAttributes : function (string) {
		if (string == null || string.length < 2){
			return {};
		}

		var attributeName = "";
		var attributeValue = "";
		var attributes = {};
		var whiteSpaceRegExp = new RegExp('^[ \n\r\t]+', 'g');

		var withInName = false, withInValue = false;

		for( var i=0,iLength=string.length ; i<iLength ; i++ ) {
			var chr = string.charAt(i);

			if ((chr == '"' || chr == "'") && !withInValue){
				withInValue = true;
			}else if ((chr == '"' || chr == "'") && withInValue) {
				withInValue = false;

				var pos = attributeName.lastIndexOf(' ');
				if (pos != -1){
					attributeName = attributeName.substring(pos+1);
				}

				attributes[attributeName.toLowerCase()] = attributeValue.substring(1);

				attributeName = "";
				attributeValue = "";
			} else if (!whiteSpaceRegExp.test(chr) && !withInName && !withInValue){
				withInName = true;
			}
			if (chr == '=' && withInName){
				withInName = false;
			}
			if (withInName){
				attributeName  += chr;
			}
			if (withInValue){
				attributeValue += chr;
			}
		}

		return attributes;
	},

	mceEditor2String: function (/*String*/content) {
		// replace preview images with epItemContent divs
		var startPos = -1;
		while ((startPos = content.indexOf('<img', startPos+1)) != -1) {
			var endPos = content.indexOf('>', startPos) + 1;
			var attributesString = content.substring(startPos + 4, endPos);
			var attribs = this.parseAttributes(attributesString);
			if (attribs['class'] == "epItemContent") {
				// replace
				var start = content.substring(0, startPos);
				var end   = content.substring(endPos);
				var old   = content.substring(startPos, endPos);
				var info = this.decodeInfo(attribs['ep_info']);
				var object = epages.cartridges.de_epages.design.MceContent.prototype.LOAD(info);
				if (object !== undefined) {
					// ATTENTION: do not change the order of these attributes
					var newString = '<!-- BEGIN_GADGET -->\n<div class="epItemContent ep_info:' + attribs['ep_info'] + '">' + object.contentString(info) + '<'+'/div>\n<!-- END_GADGET -->';
					content = start + newString + end;
				} else {
					startPos = endPos;
				}
			} else {
				startPos = endPos;
			}
		}
		return content; //String
	},

	load: function (domObject) {
		domObject.innerHTML = this.contentString(this.info(), false);
	},

	getIframeDocument: function (domObject) {
		return $E(domObject).getIframeDocument();
	},

	loadPreview: function (domObject) {
		var iframeDoc = this.getIframeDocument(domObject),
			iframeWin = iframeDoc.defaultView,
			bodyNode = iframeDoc.getElementsByTagName('body')[0],
			scriptType,
			scriptContent,
			scripts,
			script;

		if( bodyNode && iframeWin ){
			bodyNode.innerHTML = this.contentString(this.info(), true);

			scripts = bodyNode.getElementsByTagName('script') || [];

			for( var i=0,iLength=scripts.length ; i<iLength ; i++ ){
				script = scripts[i];
				scriptType = dojo.attr( script, 'type' );
				if( !scriptType || /javascript/i.test(scriptType) ){
					scriptContent = script.innerHTML;
					if( scriptContent && /\S/.test( scriptContent ) ){
						(function( scriptContent ){
							var window = iframeWin,
								document = window.document;
							iframeWin['eval'].call( iframeWin, scriptContent );
						})( scriptContent );
					}
				}
			}
		}
		else{
			console.warn('loadPreview: ' + ( iframeWin ? 'iframe body' : 'window object of iframe' ) + ' not found in epages.cartridges.de_epages.design.MceContent');
		}
	},

	saveFormAndLoadPreview: function (domObject) {
		this.saveForm();
		this.loadPreview(domObject);
	},

	saveFormAndMceInsertContent: function () {
		this.saveForm();
		this.mceInsertContent();
	},

	LOAD: function(options) {
		if (options.contentClass === undefined || options.contentClass == '') {
			console.error('cant load object without contentClass.');
			return undefined;
		}
		if (window[options.contentClass] === undefined){
			dojo["require"](options.contentClass.toLowerCase());
		}
		var obj = new(eval(options.contentClass))(options);
		return obj;
	},

	string2Preview:function(content){
		//summary: replace Gadget with place holder for editing
		//regular Expression to find ep_info on old gadget where ep_info was an attribute and on new gadget where ep_info is inside style attribute
		var epInfoRegEx = new RegExp ("<!--\\s*BEGIN_GADGET\\s*-->[\\s\\S]*?<div\\s+(class=\"epItemContent\"\\s+ep_info=\"|class=\"epItemContent ep_info:)(.+?)\"?>[\\s\\S]*?<!--\\s*END_GADGET\\s*-->","mig");
		var regExResult;
		var resultContent = content;
		// while-loop is necessary to find all gadgets inside the content string regExp-object uses internal method do find the next match
		// so we habe to do it till we find the last match
		while((regExResult = epInfoRegEx.exec(content))){
			if(regExResult && regExResult[2]){ //check if new ep_info was found
				var decodedInfo = this.decodeInfo(regExResult[2]);
				var gadgetObject = epages.cartridges.de_epages.design.MceContent.prototype.LOAD(decodedInfo);
				var replaceContent = gadgetObject.previewString(decodedInfo);
				//need  copy of content for correct working RegExp-object while looping through all gadgets inside content
				//replace gadget with preview image
				resultContent = resultContent.replace(regExResult[0],replaceContent);
			}
		}
		return resultContent;
	}
};
