-- #105
CREATE TABLE ebaytransaction (
     ebaytransactionid integer  not null
,    ebayauctionid integer  not null
,    customerorderid integer  null
,    customerid integer  null
,    externaltransactionid varchar(30)  not null
,    ispurchased bool  not null
,    isebaycomplete bool  not null
,    ebayusername varchar(255)  not null
,    email varchar(255)  not null
,    price decimal(19,4)  null
,    quantity integer  null
,    lastmod datetime  null
,    feedbacktype integer  not null
,    feedbacktext varchar(255)  null

,   constraint pk_ebaytransaction primary key (ebaytransactionid)
,   constraint fk_ebaytransaction_ebaytransactionid foreign key (ebaytransactionid)
        references object (objectid)
,   constraint fk_ebaytransaction_ebayauctionid foreign key (ebayauctionid)
        references ebayauction (auctionid)
,   constraint fk_ebaytransaction_customerorderid foreign key (customerorderid)
        references customerorder (orderid)
,   constraint fk_ebaytransaction_customerid foreign key (customerid)
        references customer (customerid)
)
GO
CREATE INDEX i_ebaytrans_auction ON ebaytransaction (ebayauctionid, externaltransactionid)
GO
CREATE INDEX i_ebaytrans_order ON ebaytransaction (customerorderid)
GO
CREATE INDEX i_ebaytrans_customer ON ebaytransaction (customerid)
GO
