dojo.provide('epages.cartridges.de_epages.externalcontent.klicktelmap');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.io.json');

epages.cartridges.de_epages.externalcontent.KlicktelMap = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.KlicktelMap,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.KlicktelMap',
	title           : 'klicktelmap',
	type            : undefined,
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_klicktelmap.png',
	map             : undefined,
	domObject       : undefined,
	navId           : null,

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, this._getFormData());
		return info;
	},

	saveForm: function() {
		if (this.form !== undefined){
			var formElements = this.form.elements;
			for( var i=0,iLength=formElements.length ; i<iLength ; i++ ){
				if(formElements[i].value){
					formElements[i].value = epages.validate.string.filterInvalidChars(formElements[i].value);
				}
			}
			this.formData = (new epages.html.Form(this.form)).get();
		}

		var formWidth = this.formData.get('KlicktelMapAutoWidth')[0] ? 'auto' : this.formData.get('KlicktelMapWidth')[0];
		this.width = formWidth == 'auto' ? '100%' : this._getGadgetWidth(formWidth);
		this.height = this._getGadgetHeight(this.formData.get('KlicktelMapHeight')[0]);
	},

	_getGadgetWidth: function(mapWidth) {
		return parseInt(mapWidth, 10) + 30;
	},

	_getGadgetHeight: function(mapHeight) {
		return parseInt(mapHeight, 10) + 90;
	},

	_getFormData: function () {
		var requestData = {
			'ViewAction'			: 'ViewKlicktelMap',
			'ChangeAction'		: 'CalculateKlicktelMap',
			'ObjectID'				: epages.vars.SiteID,
    	'Address' 				: this.formData.get('KlicktelMapAddress')[0],
    	'ContactPerson'  	: this.formData.get('KlicktelMapContactPerson')[0],
    	'EMail' 					: this.formData.get('KlicktelMapEMail')[0],
    	'MapWidth'  			: this.formData.get('KlicktelMapAutoWidth')[0] ? 'auto' : this.formData.get('KlicktelMapWidth')[0],
    	'MapHeight' 			: this.formData.get('KlicktelMapHeight')[0],
    	'LayoutLR'  			: this.formData.get('KlicktelMapLayoutLR')[0] == "0" ? 0 : 1,
    	'ShowAddress'  		: this.formData.get('KlicktelMapShowAddress')[0] == "1" ? 1 : 0,
    	'UseRoute'  			: this.formData.get('KlicktelMapUseRoute')[0] == "1" ? 1 : 0,
    	'LargeNavigation'	: this.formData.get('KlicktelMapLargeNavigation')[0] == "0" ? 0 : 1
		};
		return requestData;
	},

	loadPreview: function (domObject){
		var info = epages.vars.externalcontent[this.navId].object.info();
		domObject.src = '?'+dojo.objectToQuery(this._getFormData());
	},

	contentString: function (info, ispreview) {
		var widthValue = info.MapWidth == 'auto' ? '100%' : this._getGadgetWidth(info.MapWidth);
		var finalstring =
				'<iframe src="?'
			+	'ViewAction='+encodeURIComponent(info.ViewAction)
			+	'&ChangeAction='+encodeURIComponent(info.ChangeAction)
			+	'&ObjectID='+encodeURIComponent(info.ObjectID)
			+	'&Address='+encodeURIComponent(info.Address)
			+	'&MapWidth='+encodeURIComponent(info.MapWidth)
			+	'&MapHeight='+encodeURIComponent(info.MapHeight)
			+	'&ContactPerson='+encodeURIComponent(info.ContactPerson)
			+	'&EMail='+encodeURIComponent(info.EMail)
			+	'&UseRoute='+encodeURIComponent(info.UseRoute)
			+	'&LargeNavigation='+encodeURIComponent(info.LargeNavigation)
			+	'&ShowAddress='+encodeURIComponent(info.ShowAddress)
			+	'&LayoutLR='+encodeURIComponent(info.LayoutLR)
		  + '" '
		  + 'width='+ widthValue +' '
		  + 'height='+ this._getGadgetHeight(info.MapHeight) +' '
		  + 'frameborder=0 '
		  + '></iframe>';
		return finalstring;
	}

});