use Test::More;
use URI::Escape qw (uri_unescape);
use strict;
use DE_EPAGES::Core::API::File  qw( GetFileNames GetFileContentLines);
use DE_EPAGES::Core::API::PerlTools qw (unique);
use DE_EPAGES::Core::API::Net qw (GetHttpResponse);
use Time::HiRes qw (time);

sub testFeedUrl {
    my $Feed = shift;
    my $hTestResponse = GetHttpResponse($Feed, undef, 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0; WOW64; Trident/4.0;)');

    return 0 if $hTestResponse->code != 200;
    return 1;
}


my $time1 = time;
my $CartridgePackage = 'DE_EPAGES::ExternalContent::Templates::MBO::RSS';
$CartridgePackage =~ s/::/\//g;
my $aAllFileNames = GetFileNames( "$ENV{EPAGES_CARTRIDGES}/$CartridgePackage" , {'recursive' => 1} );
my @FileNames = grep{/\.html$/} @$aAllFileNames;
my @Feeds = ();
foreach my $File (@FileNames){
    my $aLines = GetFileContentLines($File);
    foreach my $Line (@$aLines){
        my ($Url) = ($Line =~ /value=\"(http.*?)\"/i);
        push @Feeds, uri_unescape($Url) if defined $Url;
    }
}
@Feeds = unique @Feeds;

plan tests => scalar @Feeds;
foreach my $Feed (@Feeds){
    my $wrongRequests = 0;
    if(!testFeedUrl($Feed)) {
        for(my $i = 0; $i < 10; $i++){
            if(!testFeedUrl($Feed)) {
                $wrongRequests++;
            }
        }
    }
    ok ( $wrongRequests < 10, $Feed);
}
my $time2 = time;
printf "need %.3f seconds\n", $time2-$time1;

