/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ajax
 *
 * @revision		$Revision: 1.9 $
 */

jQuery.plugin( 'ep.ajax', 'ep.core', function( $, undefined ){

	ep.extend({
		ajax: function( settings ){

			if( settings.dataType === 'json' ){
				var _beforeSend = settings.beforeSend,
					_success = settings.success || $.noop,
					_error = settings.error || $.noop;

				$.extend(settings,{
					beforeSend: function( xhr, s ){
						xhr.setRequestHeader("Accept", "application/json");
						if( _beforeSend ){
							_beforeSend( xhr, s );
						}
					},
					success: function( data, status, xhr ){
						if( data && data.Errors ){
							xhr.statusText = 'error';
							_error.call( this, xhr, 'error', data.Errors );
						}
						else{
							_success.call( this, data, status, xhr );
						}
					}
				});
			}

			if( !settings.url ){
				settings.url = ep.config.baseUrl;
			}

			return $.ajax(settings);
		}
	});

});
