/*
 * @author			Emanuel Vitzthum
 * @copyright		© 2011 jQuery SDK v1.0
 * @info			http://www.jquerysdk.com
 *
 * @license			Duale licensed under the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL (http://www.gnu.org/licenses/gpl.html)
 *
 * @plugin			jQuery.event.special.load
 */

jQuery.plugin( 'jQuery.event.special.load', function( $, undefined ){

	var loadCache = {};

	$.extend( $.event.special, {
		load: {
			add: function( bind ){
				var _handler = bind.handler;
				// fix image onLoad event
				if( this.nodeName && this.nodeName.toUpperCase()==='IMG' ){
					var src = this.getAttribute('src');

					bind.handler = function(event){
						if( loadCache[src] ){
							_handler.apply(this,arguments);
						}
						else{
							var self = this,
								args = arguments,
								img = new Image();

							img.onload = function(){
								loadCache[src] = true;
								_handler.apply(self,args) ;
							};

							img.src = src;
						}
					};

					$.event.trigger.call( $.event, 'load', undefined, this );
				}
			}
		}
	});

});