use Test::More tests => 1;
use strict;
use Config;

use DE_EPAGES::Core::API::File qw( ExistsDirectory DeleteDirectory );
use DE_EPAGES::Core::API::SystemCommand qw( SystemCommand );

# init test environment
my $Perl = $Config{osname} eq 'MSWin32' ? 'perl' : $ENV{'PERL'};
my $Script = join('/',$ENV{'EPAGES_CARTRIDGES'},'DE_EPAGES/JQuery/Scripts/DictionaryConverter.pl');
my %Params = (
    '-storetype' => 'Site',
    '-version' => '6.x.t',
    '-cartridge' => 'ALL',
);
my $TestDir = join('/',$ENV{'EPAGES_SHARED'},'WebRoot/StoreTypes', $Params{'-version'});
my $TargetDir = join('/',$TestDir, $Params{'-storetype'});

# run dictionary converter
SystemCommand(join(' ', $Perl, $Script, map{ join(' ', $_, $Params{$_}) } keys %Params));

# test if right directory has been created
ok( ExistsDirectory($TargetDir), $TargetDir);

# finish test and tidy up
DeleteDirectory($TestDir, {'recursive' => 1});
