use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::MeinPaket::API::Object::RegisteredMerchant;
use Test::More;

sub Main {
    testMerchant();
    done_testing();
}

sub testMerchant {
    my $Merch = DE_EPAGES::MeinPaket::API::Object::RegisteredMerchant->new();
    $Merch->set( {
            'RegistrationMonth' => 10,
            'RegistrationYear'  => 2010,
            'ShopAlias'         => 'Test'
        }
    );

    is( $Merch->get('RegistrationMonth'), 10,     'Month' );
    is( $Merch->get('RegistrationYear'),  2010,   'Year' );
    is( $Merch->get('ShopAlias'),         'Test', 'Test' );

    my $hInfo = $Merch->tleHash;
    is( $hInfo->{'RegistrationMonth'}, 10,     'Month' );
    is( $hInfo->{'RegistrationYear'},  2010,   'Year' );
    is( $hInfo->{'ShopAlias'},         'Test', 'Test' );
}

RunScript( Sub => \&Main );
