IF OBJECT_ID('i_StringAttribute') IS NOT NULL
    DROP PROCEDURE i_StringAttribute
GO
CREATE PROCEDURE i_StringAttribute (
    @ObjectID             int          
,   @AttributeID          int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_stringattribute
    ELSE                     BEGIN TRANSACTION ti_stringattribute

        INSERT INTO stringattribute
               ( objectid, attributeid)
        SELECT  @ObjectID,@AttributeID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_stringattribute
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_stringattribute
    RETURN 0
END
GO
