IF OBJECT_ID('i_LocalizedStringAttribute') IS NOT NULL
    DROP PROCEDURE i_LocalizedStringAttribute
GO
CREATE PROCEDURE i_LocalizedStringAttribute (
    @ObjectID             int          
,   @AttributeID          int          
,   @LanguageID           int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_localizedstringattribute
    ELSE                     BEGIN TRANSACTION ti_localizedstringattribute

        INSERT INTO localizedstringattribute
               ( objectid, attributeid, languageid)
        SELECT  @ObjectID,@AttributeID,@LanguageID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_localizedstringattribute
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_localizedstringattribute
    RETURN 0
END
GO
