-- #203
CREATE TABLE users (
     userid               integer  not null
,    localeid             char(5)  not null
,    currencyid           char(3)  not null
,    password             varchar(64)  not null
,    isactivated          bool  not null
,    deleteconfirmation   bool  not null
,    islogincookieallowed bool  not null
,    ishtmlemailallowed   bool  not null
,    reminderquestion     varchar(200)  null
,    challengephrase      varchar(200)  null
,    email                varchar(150)  null COLLATE utf8_general_ci
,    countloginfailure    integer  null
,    lastloginfailure     datetime  null
,    name                 varchar(255)  null
,    isemailverified      bool  not null

,   constraint pk_user                          primary key (userid)
,   constraint fk_users_trustee                 foreign key (userid)
        references trustee                          (trusteeid)
,   constraint fk_users_currency                foreign key (currencyid)
        references currency                         (currencyid)
,   constraint fk_users_locale                  foreign key (localeid)
        references locale                           (localeid)
)
GO
CREATE INDEX i_user_email ON users (email)
GO
