/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.presentation.history
 *
 * @revision		$Revision: 1.1 $
 */

jQuery.plugin( 'de_epages.presentation.history', ['de_epages.core', 'jQuery.storage', 'jQuery.scope'], function( $, undefined ){

	var historyData = $.localStorage('history') || [],
	
		historySave = function(){
			$.localStorage('history', historyData );
		},
		
		historyHandle = $.extend( $.scope('de_epages.presentation.history'), {
			
			add: function( add ){
				if( !add ){
					add = {
						title:			$('title').text(),
						objectId:		ep.config.objectId,
						viewAction:		ep.config.viewAction
					};
				}
				if( !add.title ){
					add.title = '';
				}
				add.id = add.objectId + ':' + add.viewAction;
				
				// remove duplicate
				$.each( historyData, function( i, data ){
					if( data.id == add.id ){
						historyData.splice(i,1);
						return false;
					}
				});
				
				historyData.unshift(add);
				historyData = historyData.splice(0,40);
				historySave();
			},
	
			get: function( i ){
				return i===undefined ? historyData : historyData[i];
			},
			
			remove: function( i ){
				historyData = i===undefined ? [] : historyData.splice( i, 1 );
				historySave();
			},
			
			removeByObjectId: function( objectId ){
				for( var i=0,iLength=historyData.length ; i<iLength ; i++ ){
					var historyItem = historyData[i];
					
					if( historyItem.objectId === objectId ){
						historyData.splice(i,1);
						i--;
						iLength--;
					}
				};
				historySave();
			}
		
		});

	historyHandle.add();

});
