IF OBJECT_ID('i_TemplateMapStringAttribute') IS NOT NULL
    DROP PROCEDURE i_TemplateMapStringAttribute
GO
CREATE PROCEDURE i_TemplateMapStringAttribute (
    @TemplateMapID        int          
,   @Name                 varchar(255) 
,   @Value                varchar(255) 
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_templatemapstrattr
    ELSE                     BEGIN TRANSACTION ti_templatemapstrattr

        INSERT INTO templatemapstrattr
               ( templatemapid, name, value)
        SELECT  @TemplateMapID,@Name,@Value

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_templatemapstrattr
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_templatemapstrattr
    RETURN 0
END
GO
