-- #602
CREATE TABLE menu (
    menuid               int           not null
,   pagetypeid           int           not null
,   template             varchar(255)  not null
,   basemenuid           int           null
,   parentmenuid         int           null
,   actionid             int           null
,   position             int           not null
,   name                 varchar(255)  not null

,   constraint pk_menu                          primary key (menuid)
,   constraint fk_menu_pagetypeid               foreign key (pagetypeid)
        references pagetype                         (pagetypeid)
,   constraint fk_menu_actionid                 foreign key (actionid)
        references action                           (actionid)
,   constraint fk_menu_parentmenuid             foreign key (parentmenuid)
        references menu                             (menuid)
,   constraint fk_menu_basemenuid               foreign key (basemenuid)
        references menu                             (menuid)
)
GO
CREATE UNIQUE INDEX u_menu_pagetype_name ON menu (pagetypeid, name)
GO
CREATE INDEX i_menu_parent ON menu (parentmenuid)
GO
CREATE INDEX i_menu_action ON menu (actionid)
GO
CREATE INDEX i_menu_base ON menu (basemenuid)
GO
