IF OBJECT_ID('i_SessionParameter') IS NOT NULL
    DROP PROCEDURE i_SessionParameter
GO
CREATE PROCEDURE i_SessionParameter (
    @IntSessionID         int          
,   @SessionAttributeID   int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_sessionparameter
    ELSE                     BEGIN TRANSACTION ti_sessionparameter

        INSERT INTO sessionparameter
               ( intsessionid, sessionattributeid)
        SELECT  @IntSessionID,@SessionAttributeID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_sessionparameter
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_sessionparameter
    RETURN 0
END
GO
