#==============================================================================
# package      DE_EPAGES::Presentation::Script::createMissingCurrencyFiles
# state        private
# description  This script looks into the DE_EPAGES/Object/Database/XML/Currencies_4217.xml file and
#               finds all missing javascript language files in DE_EPAGES/JQuery/Data/Public/GUI/ep/i18n/
#               and creates it
#==============================================================================
package MY::Parser;
use base DE_EPAGES::XML::API::BaseImportHandler;
use strict;
use Test::More;
use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Core::API::File qw ( ExistsFile );

sub Main{
    my $Parser =MY::Parser->new;
    $Parser->importXML("$ENV{EPAGES_CARTRIDGES}/DE_EPAGES/Object/Database/XML/Currencies_4217.xml");
    done_testing;
}

sub start_Currency{
    my $self    =shift;
    my ($Element) = @_;

    my $hAttributes = $self->getAttributes( $Element );
    my $CurrencyID  = $hAttributes->{'CurrencyID'};
    my $isUsed      = $hAttributes->{'IsUsed'};
    if($isUsed == 1){
        ok(ExistsFile("$ENV{EPAGES_CARTRIDGES}/DE_EPAGES/JQuery/Data/Public/GUI/ep/i18n/$CurrencyID.js"),"$CurrencyID.js exists");
    }
    return;
}



RunScript(Sub=>\&Main, Debug=>1);