-- #102
CREATE TABLE priceministeroffer (
    priceministerofferid int           not null
,   productid            int           null
,   currencyid           char(3)       not null
,   portalconfigid       int           null
,   parentofferid        int           null
,   priceministercondition tinyint       null
,   priceministerconditionnote varchar(1024)  null
,   priceministerprice   money         null
,   laststocklevel       float         null
,   laststockupdate      datetime      null
,   onlinestatus         tinyint       not null
,   lastbestpriceupdate  datetime      null
,   bestprice            money         null
,   ispricechanged       bit           not null
,   psin                 varchar(11)   null
,   errorcode            varchar(4096)  null
,   errormessage         varchar(8192)  null
,   importid             varchar(32)   null

,   constraint pk_priceministeritemprice        primary key (priceministerofferid)
,   constraint fk_priceministeroffer_currency   foreign key (currencyid)
        references currency                         (currencyid)
,   constraint fk_priceministeroffer_portalco   foreign key (portalconfigid)
        references portalconfig                     (portalconfigid)
,   constraint fk_priceministeroffer_object     foreign key (priceministerofferid)
        references object                           (objectid)
,   constraint fk_priceministeroffer_product    foreign key (productid)
        references product                          (productid)
,   constraint fk_priceministeroffer_pricemin   foreign key (parentofferid)
        references priceministeroffer               (priceministerofferid)
)
GO
CREATE UNIQUE INDEX u_portalconfigid_productid ON priceministeroffer (portalconfigid, productid)
GO
CREATE INDEX i_productid ON priceministeroffer (productid)
GO
CREATE INDEX i_portalconfigid_status ON priceministeroffer (portalconfigid, onlinestatus)
GO
CREATE INDEX i_parentofferid ON priceministeroffer (parentofferid)
GO
