-- #102
CREATE TABLE priceministertransaction (
    priceministertransactionid int           not null
,   productid            int           null
,   portalconfigid       int           null
,   externalorderid      varchar(24)   not null
,   externalorderitemcode varchar(24)   not null
,   externaldocumentid   varchar(24)   not null
,   sku                  varchar(255)  not null
,   title                varchar(255)  null
,   quantity             int           not null
,   price                money         not null
,   shipping             money         not null
,   email                varchar(255)  not null
,   fees                 money         not null
,   ordertimestamp       datetime      not null
,   fulfillmenttimestamp datetime      null

,   constraint pk_priceministertransaction      primary key (priceministertransactionid)
,   constraint fk_priceministertransaction_pr   foreign key (productid)
        references product                          (productid)
,   constraint fk_priceministertransaction_ob   foreign key (priceministertransactionid)
        references object                           (objectid)
,   constraint fk_priceministertransaction_po   foreign key (portalconfigid)
        references portalconfig                     (portalconfigid)
)
GO
CREATE INDEX i_productid ON priceministertransaction (productid)
GO
CREATE INDEX i_portalconfigid ON priceministertransaction (portalconfigid)
GO
CREATE INDEX i_externalorderid ON priceministertransaction (externalorderid)
GO
