-- #102
CREATE TABLE priceministeroffer (
     priceministerofferid integer  not null
,    productid            integer  null
,    currencyid           char(3)  not null
,    portalconfigid       integer  null
,    parentofferid        integer  null
,    priceministercondition tinyint  null
,    priceministerconditionnote varchar(1024)  null
,    priceministerprice   decimal(19,4)  null
,    laststocklevel       double  null
,    laststockupdate      datetime  null
,    onlinestatus         tinyint  not null
,    lastbestpriceupdate  datetime  null
,    bestprice            decimal(19,4)  null
,    ispricechanged       bool  not null
,    psin                 varchar(11)  null
,    errorcode            varchar(4096)  null
,    errormessage         varchar(8192)  null
,    importid             varchar(32)  null

,   constraint pk_priceministeritemprice        primary key (priceministerofferid)
,   constraint fk_priceministeroffer_currency   foreign key (currencyid)
        references currency                         (currencyid)
,   constraint fk_priceministeroffer_portalco   foreign key (portalconfigid)
        references portalconfig                     (portalconfigid)
,   constraint fk_priceministeroffer_object     foreign key (priceministerofferid)
        references object                           (objectid)
,   constraint fk_priceministeroffer_product    foreign key (productid)
        references product                          (productid)
,   constraint fk_priceministeroffer_pricemin   foreign key (parentofferid)
        references priceministeroffer               (priceministerofferid)
)
GO
CREATE UNIQUE INDEX u_portalconfigid_productid ON priceministeroffer (portalconfigid, productid)
GO
CREATE INDEX i_productid ON priceministeroffer (productid)
GO
CREATE INDEX i_portalconfigid_status ON priceministeroffer (portalconfigid, onlinestatus)
GO
CREATE INDEX i_parentofferid ON priceministeroffer (parentofferid)
GO
