-- #102
CREATE TABLE priceministertransaction (
     priceministertransactionid integer  not null
,    productid            integer  null
,    portalconfigid       integer  null
,    externalorderid      varchar(24)  not null
,    externalorderitemcode varchar(24)  not null
,    externaldocumentid   varchar(24)  not null
,    sku                  varchar(255)  not null
,    title                varchar(255)  null
,    quantity             integer  not null
,    price                decimal(19,4)  not null
,    shipping             decimal(19,4)  not null
,    email                varchar(255)  not null
,    fees                 decimal(19,4)  not null
,    ordertimestamp       datetime  not null
,    fulfillmenttimestamp datetime  null

,   constraint pk_priceministertransaction      primary key (priceministertransactionid)
,   constraint fk_priceministertransaction_pr   foreign key (productid)
        references product                          (productid)
,   constraint fk_priceministertransaction_ob   foreign key (priceministertransactionid)
        references object                           (objectid)
,   constraint fk_priceministertransaction_po   foreign key (portalconfigid)
        references portalconfig                     (portalconfigid)
)
GO
CREATE INDEX i_productid ON priceministertransaction (productid)
GO
CREATE INDEX i_portalconfigid ON priceministertransaction (portalconfigid)
GO
CREATE INDEX i_externalorderid ON priceministertransaction (externalorderid)
GO
