use Test::More;
use strict;

use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Database::API::Connection qw ( RunOnStore GetTestSite  );
use DE_EPAGES::Object::API::Factory qw ( LoadObjectByPath );
use DE_EPAGES::PriceMinister::API::Object::PagerPWSItems;
use DE_EPAGES::PriceMinister::API::Object::RemotePWS;
sub testPager {
    RunOnStore(
        'Store' => GetTestSite(),
        'Sub'   => sub {
          SKIP: {
                my $Portal = LoadObjectByPath('/Portals/PriceMinister');
                my $PortalSite = $Portal->path('PriceMinister_fr_FR');
                if (!defined $PortalSite) {
                    $PortalSite = $Portal->path('PriceMinister_fr_FR_Sandbox');
                }

                my $RemotePWS = DE_EPAGES::PriceMinister::API::Object::RemotePWS->new(
                    'PWSURL'         => $PortalSite->get('PWSURL'),
                    'Logging'        => $Portal->get('Logging'),
                );

                my $Pager = DE_EPAGES::PriceMinister::API::Object::PagerPWSItems->new(
                {
                    'ObjectID'      => 1,
                    'RemotePWS'     => $RemotePWS,
                    'PSIN'          => undef,
                    'UPCEAN'        => undef,
                    'ProductName'   => 'pack',
                    'Page'          => 1,
                });

                my $Page  = $Pager->page;
                my $Items = $Page->{'Pager'}->{'Items'};
                cmp_ok( scalar @{$Items}, '>', 0, ( scalar @{$Items} ) . ' results found for PWS keyword search.' );
          };
        }
    );
}

sub Main {
    testPager();
    done_testing();
    return;
}

RunScript( Sub => \&Main );

1;
