-- #104
CREATE TABLE portalconfig (
     portalconfigid       integer  not null
,    shopid               integer  not null
,    portalid             integer  not null
,    portalsiteid         integer  not null
,    portalmerchantid     varchar(255)  null
,    add2basket           bool  not null
,    exportallproducts    bool  not null
,    exportallvariations  bool  not null
,    shippingmethodid     integer  null
,    imageattributeid     integer  null
,    descriptionattributeid integer  null
,    shortdescriptionattributeid integer  null
,    lastexportdate       datetime  null
,    lastuploaddate       datetime  null
,    exportinterval       integer  not null
,    ftplogin             varchar(255)  null
,    ftppassword          varchar(255)  null
,    ftpfilename          varchar(255)  null

,   constraint pk_portalconfig                  primary key (portalconfigid)
,   constraint fk_portalconfig_shop             foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_portalconfig_attribute        foreign key (imageattributeid)
        references attribute                        (attributeid)
,   constraint fk_portalconfig_attribute_1      foreign key (descriptionattributeid)
        references attribute                        (attributeid)
,   constraint fk_portalconfig_shippingmethod   foreign key (shippingmethodid)
        references shippingmethod                   (shippingmethodid)
,   constraint fk_portalconfig_portalsite       foreign key (portalsiteid)
        references portalsite                       (portalsiteid)
,   constraint fk_portalconfig_object           foreign key (portalconfigid)
        references object                           (objectid)
,   constraint fk_portalconfig_attribute_2      foreign key (shortdescriptionattributeid)
        references attribute                        (attributeid)
,   constraint fk_portalconfig_portal           foreign key (portalid)
        references portal                           (portalid)
)
GO
CREATE INDEX i_portal_shop ON portalconfig (shopid)
GO
